=== debian/changelog ===
ros-lunar-mavlink (2019.4.4-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 04 Apr 2019 13:00:30 -0000
