=== debian/control ===
Source: ros-lunar-mavlink
Section: misc
Priority: extra
Maintainer: Vladimir Ermakov <vooon341@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, python-dev, python-future, python-lxml, python-setuptools
Homepage: http://qgroundcontrol.org/mavlink/
Standards-Version: 3.9.2

Package: ros-lunar-mavlink
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-dev, ros-lunar-catkin
Description: MAVLink message marshaling library.
 This package provides C-headers and C++11 library for both 1.0 and 2.0 versions of protocol. For pymavlink use separate install via rosdep (python-pymavlink).
